function f=Bs_call_american(rate,dyield,sigma,K,maturity,...
     dividend, dividends_times, S0)
 %function that price american option with BS
ndiv=length(dividends_times);
dividends=dividend*ones(1,length(dividends_times));
ov_rate=rate;
 iJ=9; lenx=3; flag=int8('C');   lower=max(0,2^(iJ-10)*300);    upper=max(0,2^(iJ-10)*300); 
 dt= 7/365;
 x=[log(0.8*S0),log(S0),log(1.2*S0)]; 
 Noptions=1;
 position=2;
 total_var_log_BS=sigma*sigma;
 max_mean_log=log(S0*1.2)+(rate-dyield -total_var_log_BS/2)*maturity;
 min_mean_log=log(S0*0.8)+(rate-dyield -total_var_log_BS/2)*maturity;
 ystart=min(min_mean_log-15*sqrt(total_var_log_BS),log(K)-10*sigma);
yend=max(max_mean_log+15*sqrt(total_var_log_BS),log(K)+10*sigma);

 xx=libpointer('doublePtr',x);
 K_tp=libpointer('doublePtr',K);
 ystart_tp=libpointer('doublePtr',ystart);
 yend_tp=libpointer('doublePtr',yend);
 y=zeros(1,3*Noptions);
z=zeros(1,3*Noptions);
BS_resultp=libpointer('doublePtr',y);
BS_errorp=libpointer('doublePtr',z);
 calllib('FRP', 'PriceBS',rate,ov_rate,dyield,sigma,K_tp,maturity,...
     dividends, dividends_times,ndiv, iJ,lenx, S0,BS_resultp,BS_errorp,flag,...
     lower, upper,dt,xx, ystart_tp, yend_tp,Noptions);
 f_tmp=BS_resultp.value;
 f=f_tmp(position);
end
